package agentrouble;

import java.util.*;

public class Inscritor<Chave, Dado> {
	Map<Chave, Collection<Dado>> objetos;
	Map<Dado, Collection<Dado>> cruzadas;
	Map<Dado, Boolean> referencias;

	public Inscritor() {
		objetos = new TreeMap<Chave, Collection<Dado>>();
		referencias = new TreeMap<Dado, Boolean>();
		cruzadas = new TreeMap<Dado, Collection<Dado>>();
	}
	

	public void inscreve(Chave c, Dado d) {
		Collection<Dado> aux = objetos.get(c);
		if (aux == null)
			aux = new TreeSet<Dado>();
		aux.add(d);

		objetos.put(c, aux);
		referencias.put(d, false);
		cruzadas.put(d, aux);
	}

	public void remove(Dado d) {
		Collection<Dado> aux = cruzadas.get(d);
		aux.remove(d);
	}

	public Dado requer(Chave c) {
		Collection<Dado> aux = objetos.get(c);

		for (Dado d : aux) {
			Boolean b = referencias.get(d);
			if (!b) {
				referencias.put(d, true);
				return d;
			}
		}

		return null;
			
	}

	public void libera(Dado d) {
		referencias.put(d, false);
	}

	public String toString() {
		String s = "Inscritor: {\n";
		for (Chave c : objetos.keySet()) {
			s += c + " => {";
			for (Dado d : objetos.get(c)) {
				s += d + "; ";
			}
			s += "};\n";
		}
		s += "};\n";
		return s;
	}
}
